
(*

  Transformer une formule propositionnelle (construite que par des
  variables propositionnelles, ngation, conjonction et disjonction)
  en formes normale conjonctive et disjonctive.

  (Ecercice 4 du TD 3)

*)


open List;;

(* le type des formules propositionnelles *)
type formula = 
    Var of string
  | Neg of formula
  | And of formula*formula
  | Or of formula*formula;;

(* les types utiliss dans les formes normeaux *)
type literal =
    PosLit of string            (* littral positif *)
  | NegLit of string;;          (* littral ngatif *)
type clause  = literal list;;   (* clause disjonctive *)
type cnf     = clause list;;    (* forme normale conjonctive *)
type conj    = literal list;;   (* conjonction lmentaire *)
type dnf     = conj list;;      (* form normale disjonctive *)

(*
   (combine [s1;...;sk] [t1;...;tl]) renvoie
   [s1@t1;...;s1@tl;s2@t1;....;sk@tl] dans un ordre quelconque.
*)

let rec combine l1 l2 = match l1 with
    [] -> []
  | h::r -> (map (function x -> h@x) l2) @ (combine r l2);;

(*
   (dnfcnf f) renvoie la paire consistante de la forme normale
   disjonctive de f, et de la forme conjonctive normale de f.
*)

let rec dnfcnf = function
    Var s -> [[PosLit s]],[[PosLit s]]
  | Neg f ->
      let (d,c) = dnfcnf f
      and negate = function PosLit s -> NegLit s | NegLit s -> PosLit s
      in ((map (map negate) c),(map (map negate) d))
  | Or(v,w) ->
      let (dv,cv) = dnfcnf v
      and (dw,cw) = dnfcnf w
      in (dv@dw,(combine cv cw))
  | And(v,w) ->
      let (dv,cv) = dnfcnf v
      and (dw,cw) = dnfcnf w
      in ((combine dv dw),cv@cw)


(* tests *)
let form = (And 
	      ((Or ((Var "x"),(Var "y"))),
	       (Or ((Var "v"),(Var "w")))));;

(dnfcnf form);;
(dnfcnf (Neg form));;
(dnfcnf (Neg (Neg form)));;

